////////////////////////////////////////////////////////////////////////
// calc.cpp
// generated with ecppc
// date: Fri Apr 25 11:18:41 2008
//

#include <tnt/ecpp.h>
#include <tnt/convert.h>
#include <tnt/httprequest.h>
#include <tnt/httpreply.h>
#include <tnt/httpheader.h>
#include <tnt/http.h>
#include <tnt/data.h>
#include <tnt/componentfactory.h>
#include <cxxtools/log.h>
#include <stdexcept>

log_define("component.calc")

// <%pre>
// </%pre>

namespace
{
template <typename T> inline void use(const T&) { }

class _component_calc : public tnt::EcppComponent
{
    _component_calc& main()  { return *this; }

  protected:
    ~_component_calc();

  public:
    _component_calc(const tnt::Compident& ci, const tnt::Urlmapper& um, tnt::Comploader& cl);

    unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
};

static tnt::ComponentFactoryImpl<_component_calc> calcFactory("calc");

static const char* rawData = "D\000\000\000E\000\000\000F\000\000\000\306\000\000\000\312\000\000\000\317\000\000\000\371\000\000\000*\001\000\000\347\001\000\000\026\002\000\000\"\002\000\000,\002\000\000-\002\000\000.\002\000\0001\002\000\0003\002\000\000E\002\000\000\n \n\n<html>\n <head>\n  <title>Calculator</title>\n </head>\n <body bgcolor=#ffffcc>\n  <h1>Tommi's Tnt-Calculator</h1>\n\n  <form method=>   \n\n   \n   <input type=\"text\" name=\"arg1\" value=\"\"> <br>\n   <input type=\"text\" name=\"arg2\" value=\"\"> <br>\n   <input type=\"submit\" name=\"op\" value=\"+\">\n   <input type=\"submit\" name=\"op\" value=\"-\">\n   <input type=\"submit\" name=\"op\" value=\"*\">\n   <input type=\"submit\" name=\"op\" value=\"/\">\n\n\n   <input type=hidden name=method value=get>\n\n\n  </form>\n\n\n  <hr>\n     = \n\n\n </body>\n</html>\n";

// <%shared>
// </%shared>

// <%config>
// </%config>

#define SET_LANG(lang) \
     do \
     { \
       request.setLang(lang); \
       reply.setLocale(request.getLocale()); \
     } while (false)

_component_calc::_component_calc(const tnt::Compident& ci, const tnt::Urlmapper& um, tnt::Comploader& cl)
  : EcppComponent(ci, um, cl)
{
  // <%init>
  // </%init>
}

_component_calc::~_component_calc()
{
  // <%cleanup>
  // </%cleanup>
}

unsigned _component_calc::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  tnt::DataChunks data(rawData);

  // <%args>
double arg1 = qparam.has("arg1") ? tnt::stringToWithDefaultConverter<double>( 0, reply.out().getloc())(qparam.param("arg1")) :  0;
double arg2 = qparam.has("arg2") ? tnt::stringToWithDefaultConverter<double>( 0, reply.out().getloc())(qparam.param("arg2")) :  0;
char op = qparam.has("op") ? tnt::stringToWithDefaultConverter<char>( ' ', reply.out().getloc())(qparam.param("op")) :  ' ';
std::string method = qparam.param("method",  "post");
  // </%args>

  // <%cpp>
  reply.out() << data[0]; // \n
#line 8 "calc.ecpp"
  // <= this starts a c++-processing-block

  double result = 0.0;

  bool result_ok = true;
  switch (op)
  {
    case '+': result = arg1 + arg2; break;
    case '-': result = arg1 - arg2; break;
    case '*': result = arg1 * arg2; break;
    case '/': result = arg1 / arg2; break;
    default: result_ok = false;
  }


  reply.out() << data[1]; //  
  reply.out() << data[2]; // \n\n<html>\n <head>\n  <title>Calculator</title>\n </head>\n <body bgcolor=#ffffcc>\n  <h1>Tommi's Tnt-Calculator</h1>\n\n  <form method=
#line 31 "calc.ecpp"
  reply.sout() << (method);
  reply.out() << data[3]; // >   
  reply.out() << data[4]; // \n\n   
  reply.out() << data[5]; // \n   <input type="text" name="arg1" value="
#line 35 "calc.ecpp"
  reply.sout() << (arg1);
  reply.out() << data[6]; // "> <br>\n   <input type="text" name="arg2" value="
#line 36 "calc.ecpp"
  reply.sout() << (arg2);
  reply.out() << data[7]; // "> <br>\n   <input type="submit" name="op" value="+">\n   <input type="submit" name="op" value="-">\n   <input type="submit" name="op" value="*">\n   <input type="submit" name="op" value="/">\n\n
#line 42 "calc.ecpp"
 if (method == "get") {    // '%' in the first column makes a c++-one-liner

  reply.out() << data[8]; // \n   <input type=hidden name=method value=get>\n\n
#line 46 "calc.ecpp"
 }

  reply.out() << data[9]; // \n  </form>\n\n
#line 50 "calc.ecpp"
 if (result_ok) {

  reply.out() << data[10]; // \n  <hr>\n  
#line 53 "calc.ecpp"
  reply.sout() << (arg1);
  reply.out() << data[11]; //  
#line 53 "calc.ecpp"
  reply.sout() << (op);
  reply.out() << data[12]; //  
#line 53 "calc.ecpp"
  reply.sout() << (arg2);
  reply.out() << data[13]; //  = 
#line 53 "calc.ecpp"
  reply.sout() << (result);
  reply.out() << data[14]; // \n\n
#line 55 "calc.ecpp"
 }

  reply.out() << data[15]; // \n </body>\n</html>\n
  // <%/cpp>
  return HTTP_OK;
}

} // namespace

