////////////////////////////////////////////////////////////////////////
// session.cpp
// generated with ecppc
// date: Fri Apr 25 11:19:08 2008
//

#include <tnt/ecpp.h>
#include <tnt/convert.h>
#include <tnt/httprequest.h>
#include <tnt/httpreply.h>
#include <tnt/httpheader.h>
#include <tnt/http.h>
#include <tnt/data.h>
#include <tnt/componentfactory.h>
#include <cxxtools/log.h>
#include <stdexcept>

log_define("component.session")

// <%pre>
// </%pre>

namespace
{
template <typename T> inline void use(const T&) { }

class _component_session : public tnt::EcppComponent
{
    _component_session& main()  { return *this; }

  protected:
    ~_component_session();

  public:
    _component_session(const tnt::Compident& ci, const tnt::Urlmapper& um, tnt::Comploader& cl);

    unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    class subcomp_type : public tnt::EcppSubComponent
    {
        _component_session& mainComp;
        _component_session& main()  { return mainComp; }

      public:
        subcomp_type(_component_session& m, const std::string& name)
          : EcppSubComponent(m, name),
            mainComp(m)
          { }
        unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    };

    subcomp_type subcomp;
};

static tnt::ComponentFactoryImpl<_component_session> sessionFactory("session");

static const char* rawData = "d\000\000\000\201\000\000\000\244\000\000\000\300\000\000\000\345\000\000\000\005\001\000\000&\001\000\000B\001\000\000b\001\000\000}\001\000\000\247\001\000\000\006\002\000\000\t\002\000\000\013\002\000\000\015\002\000\000\017\002\000\000G\002\000\000e\002\000\000\214\002\000\000\256\002\000\000\321\002\000\000\357\002\000\000\021\003\000\000.\003\000\0004\003\000\000\nSessioncounter (component): <br>\nSessioncounter (application): <br>\nSessioncounter (page): <br>\nApplicationcounter (component): <br>\nApplicationcounter (page): <br>\nRequestcounter (component): <br>\nRequestcounter (page): <br>\nThreadcounter (component): <br>\nThreadcounter (page): <br>\n\n<div style=\"background-color:#ffa\">\n\n</div>\n\n<a href=\"session\">reload this</a> -\n<a href=\"appsession\">applicationsession only</a>\n\n\n        \n  <h1>Subcomponent</h1>\n\n  Sessioncounter (component): <br>\n  Sessioncounter (page): <br>\n  Applicationcounter (component): <br>\n  Applicationcounter (page): <br>\n  Requestcounter (component): <br>\n  Requestcounter (page): <br>\n  Threadcounter (component): <br>\n  Threadcounter (page): <br>\n\n";

// <%shared>
// </%shared>

// <%config>
// </%config>

#define SET_LANG(lang) \
     do \
     { \
       request.setLang(lang); \
       reply.setLocale(request.getLocale()); \
     } while (false)

_component_session::_component_session(const tnt::Compident& ci, const tnt::Urlmapper& um, tnt::Comploader& cl)
  : EcppComponent(ci, um, cl),
    subcomp(*this, "subcomp")
{
  // <%init>
  // </%init>
}

_component_session::~_component_session()
{
  // <%cleanup>
  // </%cleanup>
}

unsigned _component_session::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  tnt::DataChunks data(rawData);

  // <%args>
  // </%args>

#line 3 "session.ecpp"
  TNT_SESSION_COMPONENT_VAR(unsigned, s, "s", (0));   // <%session> unsigned s(0)
#line 8 "session.ecpp"
  TNT_SESSION_GLOBAL_VAR(unsigned, sa, "sa", (0));   // <%session> unsigned sa(0)
#line 13 "session.ecpp"
  TNT_SESSION_PAGE_VAR(unsigned, sp, "sp", (0));   // <%session> unsigned sp(0)
#line 18 "session.ecpp"
  TNT_APPLICATION_COMPONENT_VAR(unsigned, a, "a", (0));   // <%application> unsigned a(0)
#line 23 "session.ecpp"
  TNT_APPLICATION_PAGE_VAR(unsigned, ap, "ap", (0));   // <%application> unsigned ap(0)
#line 28 "session.ecpp"
  TNT_REQUEST_COMPONENT_VAR(unsigned, r, "r", (0));   // <%request> unsigned r(0)
#line 33 "session.ecpp"
  TNT_REQUEST_PAGE_VAR(unsigned, rp, "rp", (0));   // <%request> unsigned rp(0)
#line 38 "session.ecpp"
  TNT_THREAD_COMPONENT_VAR(unsigned, t, "t", (0));   // <%thread> unsigned t(0)
#line 43 "session.ecpp"
  TNT_THREAD_PAGE_VAR(unsigned, tp, "tp", (0));   // <%thread> unsigned tp(0)
  // <%cpp>
  reply.out() << data[0]; // \nSessioncounter (component): 
#line 47 "session.ecpp"
  reply.sout() << ( ++s );
  reply.out() << data[1]; // <br>\nSessioncounter (application): 
#line 48 "session.ecpp"
  reply.sout() << ( ++sa );
  reply.out() << data[2]; // <br>\nSessioncounter (page): 
#line 49 "session.ecpp"
  reply.sout() << ( ++sp );
  reply.out() << data[3]; // <br>\nApplicationcounter (component): 
#line 50 "session.ecpp"
  reply.sout() << ( ++a );
  reply.out() << data[4]; // <br>\nApplicationcounter (page): 
#line 51 "session.ecpp"
  reply.sout() << ( ++ap );
  reply.out() << data[5]; // <br>\nRequestcounter (component): 
#line 52 "session.ecpp"
  reply.sout() << ( ++r );
  reply.out() << data[6]; // <br>\nRequestcounter (page): 
#line 53 "session.ecpp"
  reply.sout() << ( ++rp );
  reply.out() << data[7]; // <br>\nThreadcounter (component): 
#line 54 "session.ecpp"
  reply.sout() << ( ++t );
  reply.out() << data[8]; // <br>\nThreadcounter (page): 
#line 55 "session.ecpp"
  reply.sout() << ( ++tp );
  reply.out() << data[9]; // <br>\n\n<div style="background-color:#ffa">\n
  // <& subcomp ...
#line 58 "session.ecpp"
  tnt::QueryParams _tnt_cq0(qparam, false);
#line 58 "session.ecpp"
  main().subcomp(request, reply, _tnt_cq0);
  // &>
  reply.out() << data[10]; // \n</div>\n\n<a href="session">reload this</a> -\n<a href="appsession">applicationsession only</a>\n\n
  // <%/cpp>
  return HTTP_OK;
}

unsigned _component_session::subcomp_type::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  tnt::DataChunks data(rawData);
  // <%args>
  // </%args>

#line 68 "session.ecpp"
  TNT_SESSION_COMPONENT_VAR(unsigned, s, "s", (0));   // <%session> unsigned s(0)
#line 73 "session.ecpp"
  TNT_APPLICATION_COMPONENT_VAR(unsigned, a, "a", (0));   // <%application> unsigned a(0)
#line 78 "session.ecpp"
  TNT_REQUEST_COMPONENT_VAR(unsigned, r, "r", (0));   // <%request> unsigned r(0)
#line 83 "session.ecpp"
  TNT_THREAD_COMPONENT_VAR(unsigned, t, "t", (0));   // <%thread> unsigned t(0)
#line 13 "session.ecpp"
  TNT_SESSION_PAGE_VAR(unsigned, sp, "sp", (0));   // <%session> unsigned sp(0)
#line 23 "session.ecpp"
  TNT_APPLICATION_PAGE_VAR(unsigned, ap, "ap", (0));   // <%application> unsigned ap(0)
#line 33 "session.ecpp"
  TNT_REQUEST_PAGE_VAR(unsigned, rp, "rp", (0));   // <%request> unsigned rp(0)
#line 43 "session.ecpp"
  TNT_THREAD_PAGE_VAR(unsigned, tp, "tp", (0));   // <%thread> unsigned tp(0)
#line 8 "session.ecpp"
  TNT_SESSION_GLOBAL_VAR(unsigned, sa, "sa", (0));   // <%session> unsigned sa(0)
  // <%cpp>
  reply.out() << data[11]; // \n  
  reply.out() << data[12]; //   
  reply.out() << data[13]; //   
  reply.out() << data[14]; //   
  reply.out() << data[15]; // \n  <h1>Subcomponent</h1>\n\n  Sessioncounter (component): 
#line 89 "session.ecpp"
  reply.sout() << ( ++s );
  reply.out() << data[16]; // <br>\n  Sessioncounter (page): 
#line 90 "session.ecpp"
  reply.sout() << ( ++sp );
  reply.out() << data[17]; // <br>\n  Applicationcounter (component): 
#line 91 "session.ecpp"
  reply.sout() << ( ++a );
  reply.out() << data[18]; // <br>\n  Applicationcounter (page): 
#line 92 "session.ecpp"
  reply.sout() << ( ++ap );
  reply.out() << data[19]; // <br>\n  Requestcounter (component): 
#line 93 "session.ecpp"
  reply.sout() << ( ++r );
  reply.out() << data[20]; // <br>\n  Requestcounter (page): 
#line 94 "session.ecpp"
  reply.sout() << ( ++rp );
  reply.out() << data[21]; // <br>\n  Threadcounter (component): 
#line 95 "session.ecpp"
  reply.sout() << ( ++t );
  reply.out() << data[22]; // <br>\n  Threadcounter (page): 
#line 96 "session.ecpp"
  reply.sout() << ( ++tp );
  reply.out() << data[23]; // <br>\n\n
  // <%/cpp>
  return HTTP_OK;
}

} // namespace

